dialog sound_manager {
  title "/sound_"
  size -1 -1 171 81
  option dbu
  list 1, 1 1 169 68, size
  check "Enable", 2, 2 70 33 10
  button "Save", 3, 94 70 37 10
  button "Cancel", 4, 133 70 37 10, cancel
}
alias -l mdxx { return $shortfn($scriptdirmdx.dll) }
alias -l viewsx { return $shortfn($scriptdirviews.mdx) }
alias -l info { return $+(",$scriptdir,soundmanager.ini,") }
alias -l pop1 tokenize 32 $dll($scriptdirpopups.dll,Popup,$1-) | if ($isid) return $1- | $iif($4- != did not select a menu item,$4-)
alias sound_ { if (!$dialog(sound_manager)) { dialog -m sound_manager sound_manager } }
on *:dialog:sound_manager:*:*: {
  if ($devent = init) {
    dll $mdxx SetMircVersion $version
    dll $mdxx MarkDialog $dname
    dll $mdxx SetFont 1,2 +a 12 300 Tahoma
    dll $mdxx SetBorderStyle 1 clientedge
    dll $mdxx SetControlMDX $dname 1 listview labeltip labeltip autoarrange labeltip extsel checkboxes report rowselect showsel > $viewsx
    did -i $dname 1 1 headerdims 25 90 223
    did -i $dname 1 1 headertext $Chr(32) $chr(9) Event $chr(9) Sound File
    if ($readini($info,enable,sound) = 1) did -c $dname 2
    did -a $dname 1 0 + 0 0 $readini($info,enable,startup) $chr(32) $chr(9) Startup $chr(9) $readini($info,file,startup)
    did -a $dname 1 0 + 0 0 $readini($info,enable,connect) $chr(32) $chr(9) Connect $chr(9) $readini($info,file,connect)
    did -a $dname 1 0 + 0 0 $readini($info,enable,disconnect) $chr(32) $chr(9) Disconnect $chr(9) $readini($info,file,disconnect)
    did -a $dname 1 0 + 0 0 $readini($info,enable,join) $chr(32) $chr(9) Join $chr(9) $readini($info,file,join)
    did -a $dname 1 0 + 0 0 $readini($info,enable,part) $chr(32) $chr(9) Part $chr(9) $readini($info,file,part)
    did -a $dname 1 0 + 0 0 $readini($info,enable,query) $chr(32) $chr(9) Query $chr(9) $readini($info,file,query)
    did -a $dname 1 0 + 0 0 $readini($info,enable,invite) $chr(32) $chr(9) Invite $chr(9) $readini($info,file,invite)
    did -a $dname 1 0 + 0 0 $readini($info,enable,notice) $chr(32) $chr(9) Notice $chr(9) $readini($info,file,notice)
    did -a $dname 1 0 + 0 0 $readini($info,enable,ctcp) $chr(32) $chr(9) CTCP $chr(9) $readini($info,file,ctcp)
    did -a $dname 1 0 + 0 0 $readini($info,enable,op) $chr(32) $chr(9) Op $chr(9) $readini($info,file,op)
    did -a $dname 1 0 + 0 0 $readini($info,enable,deop) $chr(32) $chr(9) DeOp $chr(9) $readini($info,file,deop)
    did -a $dname 1 0 + 0 0 $readini($info,enable,voice) $chr(32) $chr(9) Voice $chr(9) $readini($info,file,voice)
    did -a $dname 1 0 + 0 0 $readini($info,enable,devoice) $chr(32) $chr(9) DeVoice $chr(9) $readini($info,file,devoice)
    did -a $dname 1 0 + 0 0 $readini($info,enable,kick) $chr(32) $chr(9) Kick $chr(9) $readini($info,file,kick)
    did -a $dname 1 0 + 0 0 $readini($info,enable,ban) $chr(32) $chr(9) Ban $chr(9) $readini($info,file,ban)
    did -a $dname 1 0 + 0 0 $readini($info,enable,get) $chr(32) $chr(9) Get $chr(9) $readini($info,file,get)
    did -a $dname 1 0 + 0 0 $readini($info,enable,get-fail) $chr(32) $chr(9) Get-Fail $chr(9) $readini($info,file,get-fail)
    did -a $dname 1 0 + 0 0 $readini($info,enable,send) $chr(32) $chr(9) Send $chr(9) $readini($info,file,send)
    did -a $dname 1 0 + 0 0 $readini($info,enable,send-fail) $chr(32) $chr(9) Send-Fail $chr(9) $readini($info,file,send-fail)
    
  }
  if ($devent = sclick) {
    if ($did == 1) {
      if ($gettok($did($dname,1,1),1,32) != rclick) halt
      if (!$did(1).sel) { halt }
      dll $scriptdirpopups.dll New snd 16 16
      dll $+(",$scriptdirpopups.dll,") AddItem snd end + 1 1 Choose File $cr snd_cfile
      if ($gettok($did(sound_manager,1).seltext,15,32) != $null) {
        dll $+(",$scriptdirpopups.dll,") AddItem snd end + 1 1 Play File $cr splay $gettok($did(sound_manager,1).seltext,15-,32)
      }
      pop1 snd $mouse.dx $mouse.dy
    }
    if ($did == 3) {
      snd_save
      dialog -x sound_manager sound_manager
    }
  }
}
alias snd_save {
  set %snd_tmpnum $did(sound_manager,1).lines
  var %a = 2 , %b = 2
  ;echo -a
  while (%a <= %snd_tmpnum) {
    writeini $+(",$scriptdir,soundmanager.ini,") enable $remove($lower($gettok($did(sound_manager,1,%a),10,32)),$chr(32)) $gettok($did(sound_manager,1,%a),5,32)
    if ($gettok($did(sound_manager,1,%a),15-,32) != $null) {
      writeini $+(",$scriptdir,soundmanager.ini,") file $gettok($did(sound_manager,1,%a),10,32) $gettok($did(sound_manager,1,%a),15-,32)
    }
    inc %a
  }
  /writeini $info enable sound $did(sound_manager,2).state
  unset %snd_tmpnum
}
alias snd_cfile {
  set %snd_tmp $$sfile($scriptdir*.wav,Choose a file,Ok)
  set %snd_tmpz $gettok($did(sound_manager,1).seltext,5,32)
  if (startup isin $did(sound_manager,1).seltext) { did -o $dname 1 $did(sound_manager,1).sel 0 + 0 0 %snd_tmpz $chr(32) $chr(9) Startup $chr(9) %snd_tmp }
  if ($+($chr(32),connect) isin $did(sound_manager,1).seltext) { did -o $dname 1 $did(sound_manager,1).sel 0 + 0 0 %snd_tmpz $chr(32) $chr(9) Connect $chr(9) %snd_tmp }
  if (disconnect isin $did(sound_manager,1).seltext) { did -o $dname 1 $did(sound_manager,1).sel 0 + 0 0 %snd_tmpz $chr(32) $chr(9) Disconnect $chr(9) %snd_tmp }
  if (join isin $did(sound_manager,1).seltext) { did -o $dname 1 $did(sound_manager,1).sel 0 + 0 0 %snd_tmpz $chr(32) $chr(9) Join $chr(9) %snd_tmp }
  if (part isin $did(sound_manager,1).seltext) { did -o $dname 1 $did(sound_manager,1).sel 0 + 0 0 %snd_tmpz $chr(32) $chr(9) Part $chr(9) %snd_tmp }
  if ($+($chr(32),op) isin $did(sound_manager,1).seltext) { did -o $dname 1 $did(sound_manager,1).sel 0 + 0 0 %snd_tmpz $chr(32) $chr(9) OP $chr(9) %snd_tmp }
  if (deop isin $did(sound_manager,1).seltext) { did -o $dname 1 $did(sound_manager,1).sel 0 + 0 0 %snd_tmpz $chr(32) $chr(9) DeOP $chr(9) %snd_tmp }
  if ($+($chr(32),voice) isin $did(sound_manager,1).seltext) { did -o $dname 1 $did(sound_manager,1).sel 0 + 0 0 %snd_tmpz $chr(32) $chr(9) Voice $chr(9) %snd_tmp }
  if (devoice isin $did(sound_manager,1).seltext) { did -o $dname 1 $did(sound_manager,1).sel 0 + 0 0 %snd_tmpz $chr(32) $chr(9) DeVoice $chr(9) %snd_tmp }
  if (kick isin $did(sound_manager,1).seltext) { did -o $dname 1 $did(sound_manager,1).sel 0 + 0 0 %snd_tmpz $chr(32) $chr(9) Kick $chr(9) %snd_tmp }
  if (ban isin $did(sound_manager,1).seltext) { did -o $dname 1 $did(sound_manager,1).sel 0 + 0 0 %snd_tmpz $chr(32) $chr(9) Ban $chr(9) %snd_tmp }
  if (query isin $did(sound_manager,1).seltext) { did -o $dname 1 $did(sound_manager,1).sel 0 + 0 0 %snd_tmpz $chr(32) $chr(9) Query $chr(9) %snd_tmp }
  if (invite isin $did(sound_manager,1).seltext) { did -o $dname 1 $did(sound_manager,1).sel 0 + 0 0 %snd_tmpz $chr(32) $chr(9) Invite $chr(9) %snd_tmp }
  if (notice isin $did(sound_manager,1).seltext) { did -o $dname 1 $did(sound_manager,1).sel 0 + 0 0 %snd_tmpz $chr(32) $chr(9) Notice $chr(9) %snd_tmp }
  if (ctcp isin $did(sound_manager,1).seltext) { did -o $dname 1 $did(sound_manager,1).sel 0 + 0 0 %snd_tmpz $chr(32) $chr(9) CTCP $chr(9) %snd_tmp }
  if ($+(send,$chr(32)) isin $did(sound_manager,1).seltext) { did -o $dname 1 $did(sound_manager,1).sel 0 + 0 0 %snd_tmpz $chr(32) $chr(9) Send $chr(9) %snd_tmp }
  if (send-fail isin $did(sound_manager,1).seltext) { did -o $dname 1 $did(sound_manager,1).sel 0 + 0 0 %snd_tmpz $chr(32) $chr(9) Send-Fail $chr(9) %snd_tmp }
  if ($+(get,$chr(32)) isin $did(sound_manager,1).seltext) { did -o $dname 1 $did(sound_manager,1).sel 0 + 0 0 %snd_tmpz $chr(32) $chr(9) Get $chr(9) %snd_tmp }
  if (get-fail isin $did(sound_manager,1).seltext) { did -o $dname 1 $did(sound_manager,1).sel 0 + 0 0 %snd_tmpz $chr(32) $chr(9) Get-Fail $chr(9) %snd_tmp }
  unset %snd_*
}
alias snd_info1 {
  return $readini $info enable $1
}
alias snd_info2 {
  return $readini $info file $1
}
on *:START: if ($snd_info1(sound) == 1) && ($snd_info1(startup) == 2) && ($isfile($snd_info2(startup))) { splay $snd_info2(startup) }
on *:CONNECT: if ($snd_info1(sound) == 1) && ($snd_info1(connect) == 2) && ($isfile($snd_info2(connect))) { splay $snd_info2(connect) }
on *:DISCONNECT: if ($snd_info1(sound) == 1) && ($snd_info1(disconnect) == 2) && ($isfile($snd_info2(disconnect))) { splay $snd_info2(disconnect) }
on *:JOIN:#: if ($nick == $me) && ($snd_info1(sound) == 1) && ($snd_info1(join) == 2) && ($isfile($snd_info2(join))) { splay $snd_info2(join) }
on *:PART:#: if ($nick == $me) && ($snd_info1(sound) == 1) && ($snd_info1(part) == 2) && ($isfile($snd_info2(part))) { splay $snd_info2(part) }
on *:OP:#: if ($opnick == $me) && ($snd_info1(sound) == 1) && ($snd_info1(op) == 2) && ($isfile($snd_info2(op))) { splay $snd_info2(op) }
on *:DEOP:#: if ($opnick == $me) && ($snd_info1(sound) == 1) && ($snd_info1(deop) == 2) && ($isfile($snd_info2(deop))) { splay $snd_info2(deop) }
on *:VOICE:#: if ($vnick == $me) && ($snd_info1(sound) == 1) && ($snd_info1(voice) == 2) && ($isfile($snd_info2(voice))) { splay $snd_info2(voice) }
on *:DEVOICE:#: if ($vnick == $me) && ($snd_info1(sound) == 1) && ($snd_info1(devoice) == 2) && ($isfile($snd_info2(devoice))) { splay $snd_info2(devoice) }
on *:KICK: if ($knick == $me) && ($snd_info1(sound) == 1) && ($snd_info1(kick) == 2) && ($isfile($snd_info2(kick))) { splay $snd_info2(kick) }
on *:BAN: if ($bnick == $me) && ($snd_info1(sound) == 1) && ($snd_info1(ban) == 2) && ($isfile($snd_info2(ban))) { splay $snd_info2(ban) }
on *:OPEN:?: if ($snd_info1(sound) == 1) && ($snd_info1(query) == 2) && ($isfile($snd_info2(query))) { splay $snd_info2(query) }
on *:INVITE:#: if ($snd_info1(sound) == 1) && ($snd_info1(invite) == 2) && ($isfile($snd_info2(invite))) { splay $snd_info2(invite) }
on *:NOTICE:*:#: if ($snd_info1(sound) == 1) && ($snd_info1(notice) == 2) && ($isfile($snd_info2(notice))) { splay $snd_info2(notice) }
ctcp *:*:*: { if ($snd_info1(sound) == 1) && ($snd_info1(ctcp) == 2) && ($isfile($snd_info2(ctcp))) { splay $snd_info2(ctcp) } }
on *:FILESENT:*: if ($snd_info1(sound) == 1) && ($snd_info1(send) == 2) && ($isfile($snd_info2(send))) { splay $snd_info2(send) }
on *:SENDFAIL:*: if ($snd_info1(sound) == 1) && ($snd_info1(send-fail) == 2) && ($isfile($snd_info2(send-fail))) { splay $snd_info2(sendfail) }
on *:FILERCVD:*: if ($snd_info1(sound) == 1) && ($snd_info1(get) == 2) && ($isfile($snd_info2(get))) { splay $snd_info2(get) }
on *:GETFAIL:*: if ($snd_info1(sound) == 1) && ($snd_info1(get-fail) == 2) && ($isfile($snd_info2(get-fail))) { splay $snd_info2(getfail) }
menu menubar {
  Sound Manager
  .Open:sound_
  .-
  .Unload:.unload -rs " $+ $script $+ "
}
on 1:LOAD:{
  if ($version < 6.03) {
    echo -a 0,1*** This addon don't work in this version of mIRC ( $+ $version $+ )
    echo -a 0,1*** Please Upgrade
    .unload -rs " $+ $script $+ "
  }
  echo -a 0,1*** Sound Manager by Nutz Loaded
}
